/**
 * Popular docker images.
 *
 * It's typed in such a way that it will autocomplete the available versions for the given image, but also allows any arbitrary string.
 */
export type DockerImages = Node | (string & Record<never, never>);

type Node = "node" | `node:${NodeVersions}`;

type NodeVersions =
  | "19-alpine3.16"
  | "19.8-alpine3.16"
  | "19.8.1-alpine3.16"
  | "alpine3.16"
  | "current-alpine3.16"
  | "19-alpine"
  | "19-alpine3.17"
  | "19.8-alpine"
  | "19.8-alpine3.17"
  | "19.8.1-alpine"
  | "19.8.1-alpine3.17"
  | "alpine"
  | "alpine3.17"
  | "current-alpine"
  | "current-alpine3.17"
  | "19"
  | "19-bullseye"
  | "19.8"
  | "19.8-bullseye"
  | "19.8.1"
  | "19.8.1-bullseye"
  | "bullseye"
  | "current"
  | "current-bullseye"
  | "latest"
  | "19-bullseye-slim"
  | "19-slim"
  | "19.8-bullseye-slim"
  | "19.8-slim"
  | "19.8.1-bullseye-slim"
  | "19.8.1-slim"
  | "bullseye-slim"
  | "current-bullseye-slim"
  | "current-slim"
  | "slim"
  | "19-buster"
  | "19.8-buster"
  | "19.8.1-buster"
  | "buster"
  | "current-buster"
  | "19-buster-slim"
  | "19.8-buster-slim"
  | "19.8.1-buster-slim"
  | "buster-slim"
  | "current-buster-slim"
  | "18-alpine3.16"
  | "18.15-alpine3.16"
  | "18.15.0-alpine3.16"
  | "hydrogen-alpine3.16"
  | "lts-alpine3.16"
  | "18-alpine"
  | "18-alpine3.17"
  | "18.15-alpine"
  | "18.15-alpine3.17"
  | "18.15.0-alpine"
  | "18.15.0-alpine3.17"
  | "hydrogen-alpine"
  | "hydrogen-alpine3.17"
  | "lts-alpine"
  | "lts-alpine3.17"
  | "18"
  | "18-bullseye"
  | "18.15"
  | "18.15-bullseye"
  | "18.15.0"
  | "18.15.0-bullseye"
  | "hydrogen"
  | "hydrogen-bullseye"
  | "lts"
  | "lts-bullseye"
  | "lts-hydrogen"
  | "18-bullseye-slim"
  | "18-slim"
  | "18.15-bullseye-slim"
  | "18.15-slim"
  | "18.15.0-bullseye-slim"
  | "18.15.0-slim"
  | "hydrogen-bullseye-slim"
  | "hydrogen-slim"
  | "lts-bullseye-slim"
  | "lts-slim"
  | "18-buster"
  | "18.15-buster"
  | "18.15.0-buster"
  | "hydrogen-buster"
  | "lts-buster"
  | "18-buster-slim"
  | "18.15-buster-slim"
  | "18.15.0-buster-slim"
  | "hydrogen-buster-slim"
  | "lts-buster-slim"
  | "16-alpine3.16"
  | "16.20-alpine3.16"
  | "16.20.0-alpine3.16"
  | "gallium-alpine3.16"
  | "16-alpine"
  | "16-alpine3.17"
  | "16.20-alpine"
  | "16.20-alpine3.17"
  | "16.20.0-alpine"
  | "16.20.0-alpine3.17"
  | "gallium-alpine"
  | "gallium-alpine3.17"
  | "16-bullseye"
  | "16.20-bullseye"
  | "16.20.0-bullseye"
  | "gallium-bullseye"
  | "16-bullseye-slim"
  | "16.20-bullseye-slim"
  | "16.20.0-bullseye-slim"
  | "gallium-bullseye-slim"
  | "16"
  | "16-buster"
  | "16.20"
  | "16.20-buster"
  | "16.20.0"
  | "16.20.0-buster"
  | "gallium"
  | "gallium-buster"
  | "16-buster-slim"
  | "16-slim"
  | "16.20-buster-slim"
  | "16.20-slim"
  | "16.20.0-buster-slim"
  | "16.20.0-slim"
  | "gallium-buster-slim"
  | "gallium-slim"
  | "14-alpine3.16"
  | "14.21-alpine3.16"
  | "14.21.3-alpine3.16"
  | "fermium-alpine3.16"
  | "14-alpine"
  | "14-alpine3.17"
  | "14.21-alpine"
  | "14.21-alpine3.17"
  | "14.21.3-alpine"
  | "14.21.3-alpine3.17"
  | "fermium-alpine"
  | "fermium-alpine3.17"
  | "14-bullseye"
  | "14.21-bullseye"
  | "14.21.3-bullseye"
  | "fermium-bullseye"
  | "14-bullseye-slim"
  | "14.21-bullseye-slim"
  | "14.21.3-bullseye-slim"
  | "fermium-bullseye-slim"
  | "14"
  | "14-buster"
  | "14.21"
  | "14.21-buster"
  | "14.21.3"
  | "14.21.3-buster"
  | "fermium"
  | "fermium-buster"
  | "14-buster-slim"
  | "14-slim"
  | "14.21-buster-slim"
  | "14.21-slim"
  | "14.21.3-buster-slim"
  | "14.21.3-slim"
  | "fermium-buster-slim"
  | "fermium-slim";
